{-
An experiment with Clash: Experiment 2

Okay, this failed as expected. Because it isn't as trivial as Experiment 1.
`List.length' function is involved and its definition is recursive.
 -}

module Exp where

import Clash.Prelude
import qualified Data.List as L

topFn :: [Int] -> Int -> ([Int], Int)
topFn ls n = (n:ls, L.length ls)

topEntity
  :: Clock System
  -> Reset System
  -> Enable System
  -> Signal System Int
  -> Signal System Int
topEntity = exposeClockResetEnable $ mealy topFn []

-- $ clash Exp.hs --verilog
-- GHC: Setting up GHC took: 0.666s
-- GHC: Compiling and loading modules took: 0.445s
-- Clash: Parsing and compiling primitives took 0.266s
-- GHC+Clash: Loading modules cumulatively took 1.502s
-- Clash: Compiling Exp.topEntity
-- Clash: Normalization took 0.031s
--
-- Exp.hs:19:1: error:
--
--     Clash.Netlist.BlackBox(319): No blackbox found for: GHC.List.$wlenAcc. Did you forget to include directories containing primitives? You can use '-i/my/prim/dir' to achieve this.
--
--     The source location of the error is not exact, only indicative, as it is acquired
--     after optimizations. The actual location of the error can be in a function that is
--     inlined. To prevent inlining of those functions, annotate them with a NOINLINE pragma.
--    |
-- 19 | topEntity = exposeClockResetEnable $ mealy topFn []
--    | ^^^^^^^^^
 

  



-- {-
-- An experiment with Clash: Experiment 1

-- I expected this not to synthesize. But it did.
-- Probably because it was too simple.
--  -}

-- module Exp where

-- import Clash.Prelude

-- topFn :: [Int] -> Int -> ([Int], Bool)
-- topFn ls n = (ls, True)

-- topEntity
--   :: Clock System
--   -> Reset System
--   -> Enable System
--   -> Signal System Int
--   -> Signal System Bool
-- topEntity = exposeClockResetEnable $ mealy topFn []
